> For the complete documentation index, see [llms.txt](https://docs.lightlink.io/lightlink-protocol/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.lightlink.io/lightlink-protocol/tools-for-developers/ides.md).

# IDEs

### Remix

[Remix](https://remix.ethereum.org/) is the most popular web-based IDE for Solidity development featuring a built-in testnet virtual machine. Developers can combine it with other tools to create comprehensive Web3 applications.

[Official documentation](https://remix-ide.readthedocs.io/en/latest/)

### ChainIDE

[ChainIDE](https://chainide.com/) is a cloud-based IDE equipped with advanced tools for testing, debugging, and project storage in the cloud, facilitating collaborative teamwork.

[Official documentation](https://chainide.gitbook.io/chainide-english-1/)

### Visual Studio Code

[Visual Studio Code](https://code.visualstudio.com/) or VSC is an industry standard for developing applications of any kind and complexity. VSC supports numerous [plugins and libraries](https://marketplace.visualstudio.com/search?term=tag%3Asolidity\&target=VSCode\&category=All%20categories\&sortBy=Relevance) for Solidity development.

[Official documentation](https://code.visualstudio.com/docs)

### CryptoDo

[CryptoDo](https://www.cryptodo.app/) is an AI-powered no-code builder for business. Its modular architecture is useful for fast PoC and MVP creation with visual programming.&#x20;

[Official documentation](https://docs.cryptodo.app/)

### Forward

[Forward](https://forwardfactory.net/) is a no-code full-stack dApp building and deployment toolkit which enables people to create, customize, monetize and deploy dApp's directly to LightLink or any EVM chain. Using Forward reduces time and money to easily deploy full functioning dApps and as proof-of-concept development. Forward has recently partnered with LightLink, enabling full support for dApp deployment.

[Official documentation](<https://forwardprotocol.io/ >)

### DeFi Builder's Smart Contract Generator

[DeFi Builder](https://defibuilder.com/)'s Smart Contract Generator is an AI-powered tool that works with standard templates, customizing them based on user prompts. This approach streamlines the creation of common contracts, such as ERC-20, ERC-721, farms, etc. The generator also boasts additional features like an AI auditor trained on over 10,000 audit results, and modules for well-known DeFi mechanics.

[Official documentation](https://docs.defibuilder.com/)


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.lightlink.io/lightlink-protocol/tools-for-developers/ides.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
